// Author: J. Andreas Brentzen,
// Created: Mon Jun  5 16:58:3

//#include <iostream>
#include <assert.h>
#include "Mat2x2f.h"

using namespace std;

Mat2x2f invert(const Mat2x2f& m)
{
	float det = determinant(m);
	assert(fabs(det) > 1e-5);
	return Mat2x2f(m[1][1]/det, -m[0][1]/det, 
								 -m[1][0]/det, m[0][0]/det);
}
