#ifndef __HISTORY_H
#define __HISTORY_H

#include <list>

///
template<class T>
class History
{
  ///
  std::list<T> histlist;
  
protected:
  
  ///
  History(const History& th1,
	  const History& th2)
  {
    histlist = th1.histlist;
    std::list<T> hl2 = th2.histlist;
    histlist.splice(histlist.end(), hl2);
  }
  
  ///
  History(const T& td)
  {
    histlist.front() = td;
  }
  
  ///
  virtual ~History() {};
  
  ///
  void init_hist(const T& td)
  {
    std::list<T> hl;
    histlist = hl;
    histlist.push_front(td);
  }

  ///
  void add_to_hist(const History& th)
    {
      std::list<T> l2 = th.histlist;
      histlist.splice(histlist.end(), l2);
    }

//   void print_hist(ostream& os) const
//   {
//     for_each(histlist.begin(),histlist.end(), 
// 	     os << (*histlist));
//   }

};


#endif


