#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <stdio.h>
#include "DepthMap.h"

int DepthMap::write_map(const char* filename) const
{
  const char prefixstr[] = "P5\n# CREATOR: Carpeaux\n%d %d\n255\n";
  int f;
  if ((f = creat(filename, 0666)) == -1)
    {
      return -1;
    }
  else
    {
      char str[80];
      sprintf(str, prefixstr, width, height);
      write(f, str, strlen(str));
      
      for(int j=0; j< height; j++)
        for (int i=0; i<width; i++)
          {
            unsigned char c = depthpixel(i,j)/(far-near);
            write(f, &c , 1);
          }
    }
  close(f);
  return 1;
}
