#ifndef __MAT3X3_H
#define __MAT3X3_H

#include "Common/ExceptionStandard.h"
#include "Vec3f.h"
#include "ArithMat.h"

class Mat3x3f: public ArithMat<Vec3f, Vec3f, Mat3x3f, 3>
{
public:
  
  Mat3x3f(Vec3f _a, Vec3f _b, Vec3f _c): 
    ArithMat<Vec3f, Vec3f, Mat3x3f, 3> (_a,_b,_c) {}
  
  /// Construct the 0 matrix
  Mat3x3f() {}

};

#endif







