#ifndef __SHADER_H
#define __SHADER_H

#include "Math/Ray.h"
#include "ColorVector.h"

///
class Shader
{
public:

  /** Cast ray and shade accordingly. The first argument
      is the ray, and the second tells us whether we should assume the
      starting point of the ray is already determined */
  virtual ColorVector shade_ray(Ray&) = 0;
};


#endif
